//
//  GTRunLoop.h
//  All
//
//  Created by nhn on 10. 12. 31..
//  Copyright 2010 nhn KEH. All rights reserved.
//

#pragma once

#include <Foundation/Foundation.h>
#include <CoreFoundation/CoreFoundation.h>

@class GTRunLoopContext;
@class GTRunLoopSource;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark -
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

@protocol GTRunLoopSourceDelegate
@optional

- (void)onGTRunLoop_RegisterSource:(GTRunLoopContext *)sourceInfo;

- (void)onGTRunLoop_RemoveSource:(GTRunLoopContext *)sourceInfo;

- (void)onGTRunLoop:(GTRunLoopSource *)source didSourceFiredWithCommand:(id)command;

@end


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark -
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

@interface GTRunLoopSource : NSObject
{
	CFRunLoopSourceRef runLoopSource;
	NSMutableArray *commandBuffer;
	NSRecursiveLock *lock;
	id delegate;
	BOOL isDisposableSource;
}

@property (readonly) id delegate;

- (id)initWithDelegate:(id)aDelegate withDisposableSource:(BOOL)aIsDisposableSource;
- (void)addToRunLoop:(CFRunLoopRef)runloop;
- (void)addToCurrentRunLoop;
- (void)addToMainRunLoop;
- (void)invalidate;

// Handler method
- (void)sourceFired;

- (void)addCommand:(id)command;
- (void)fireAllCommandsOnRunLoop:(CFRunLoopRef)runloop;

@end


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark -
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

@interface GTRunLoopContext : NSObject
{
	CFRunLoopRef runLoop;
	GTRunLoopSource *source;
}

@property (readonly) CFRunLoopRef runLoop;
@property (readonly) GTRunLoopSource *source;

- (id) initWithSource:(GTRunLoopSource *)src andLoop:(CFRunLoopRef)loop;
- (BOOL)isEqual:(id)anObject;

@end

